Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class ImmutableListMultimap<K,V>

    java.lang.Object
      com.google.common.collect.ImmutableMultimap<K,V>
          com.google.common.collect.ImmutableListMultimap<K,V>

All Implemented Interfaces:
  ListMultimap<K,V>, Multimap<K,V>, Serializable

    public class ImmutableListMultimap<K,V>

extends ImmutableMultimap<K,V>
implements ListMultimap<K,V>

An immutable `ListMultimap` with reliable user-specified key and value iteration order. Does not permit null keys or values.

Unlike `Multimaps.unmodifiableListMultimap(ListMultimap)`, which is a view of a separate multimap which can still change, an instance of `ImmutableListMultimap` contains its own data and will never change. `ImmutableListMultimap` is convenient for `public static final` multimaps ("constant multimaps") and also lets you easily make a "defensive copy" of a multimap provided to your class by a caller.

Note: Although this class is not final, it cannot be subclassed as it has no public or protected constructors. Thus, instances of this class are guaranteed to be immutable.

Author:
  Jared Levy
See Also:
  Serialized Form

Nested Class Summary
`static class` | `ImmutableListMultimap.Builder<K,V>` A builder for creating immutable `ListMultimap` instances, especially `public static final` multimaps ("constant multimaps").

Method Summary
`static
`<K,V> ImmutableListMultimap.Builder<K,V>`
` | `builder()` Returns a new builder.
`static
`<K,V> ImmutableListMultimap<K,V>`
` | `copyOf(Multimap<? extends K,? extends V> multimap)` Returns an immutable multimap containing the same mappings as `multimap`.
`ImmutableList<V>` | `get(K key)` Returns an immutable list of the values for the given key.
`static
`<K,V> ImmutableListMultimap<K,V>`
` | `of()` Returns the empty multimap.
`static
`<K,V> ImmutableListMultimap<K,V>`
` | `of(K k1, V v1)` Returns an immutable multimap containing a single entry.
`static
`<K,V> ImmutableListMultimap<K,V>`
` | `of(K k1, V v1, K k2, V v2)` Returns an immutable multimap containing the given entries, in order.
`static
`<K,V> ImmutableListMultimap<K,V>`
` | `of(K k1, V v1, K k2, V v2, K k3, V v3)` Returns an immutable multimap containing the given entries, in order.
`static
`<K,V> ImmutableListMultimap<K,V>`
` | `of(K k1, V v1, K k2, V v2, K k3, V v3, K k4, V v4)` Returns an immutable multimap containing the given entries, in order.
`static
`<K,V> ImmutableListMultimap<K,V>`
` | `of(K k1, V v1, K k2, V v2, K k3, V v3, K k4, V v4, K k5, V v5)` Returns an immutable multimap containing the given entries, in order.
`ImmutableList<V>` | `removeAll(Object key)` Guaranteed to throw an exception and leave the multimap unmodified.
`ImmutableList<V>` | `replaceValues(K key, Iterable<? extends V> values)` Guaranteed to throw an exception and leave the multimap unmodified.

Methods inherited from class com.google.common.collect.ImmutableMultimap
`asMap, clear, containsEntry, containsKey, containsValue, entries, equals, hashCode, isEmpty, keys, keySet, put, putAll, putAll, remove, size, toString, values`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.google.common.collect.ListMultimap
`asMap, equals`

Methods inherited from interface com.google.common.collect.Multimap
`clear, containsEntry, containsKey, containsValue, entries, hashCode, isEmpty, keys, keySet, put, putAll, putAll, remove, size, values`

Method Detail

### of

    public static <K,V> ImmutableListMultimap<K,V> of()

  Returns the empty multimap.

### of

    public static <K,V> ImmutableListMultimap<K,V> of(K k1,
                                                      V v1)

  Returns an immutable multimap containing a single entry.

### of

    public static <K,V> ImmutableListMultimap<K,V> of(K k1,
                                                      V v1,
                                                      K k2,
                                                      V v2)

  Returns an immutable multimap containing the given entries, in order.

### of

    public static <K,V> ImmutableListMultimap<K,V> of(K k1,
                                                      V v1,
                                                      K k2,
                                                      V v2,
                                                      K k3,
                                                      V v3)

  Returns an immutable multimap containing the given entries, in order.

### of

    public static <K,V> ImmutableListMultimap<K,V> of(K k1,
                                                      V v1,
                                                      K k2,
                                                      V v2,
                                                      K k3,
                                                      V v3,
                                                      K k4,
                                                      V v4)

  Returns an immutable multimap containing the given entries, in order.

### of

    public static <K,V> ImmutableListMultimap<K,V> of(K k1,
                                                      V v1,
                                                      K k2,
                                                      V v2,
                                                      K k3,
                                                      V v3,
                                                      K k4,
                                                      V v4,
                                                      K k5,
                                                      V v5)

  Returns an immutable multimap containing the given entries, in order.

### builder

    public static <K,V> ImmutableListMultimap.Builder<K,V> builder()

  Returns a new builder. The generated builder is equivalent to the builder created by the `ImmutableListMultimap.Builder` constructor.

### copyOf

    public static <K,V> ImmutableListMultimap<K,V> copyOf(Multimap<? extends K,? extends V> multimap)

  Returns an immutable multimap containing the same mappings as `multimap`. The generated multimap's key and value orderings correspond to the iteration ordering of the `multimap.asMap()` view.

  Note: Despite what the method name suggests, if `multimap` is an `ImmutableListMultimap`, no copy will actually be performed, and the given multimap itself will be returned.

  Throws:
    `NullPointerException` - if any key or value in `multimap` is null

### get

    public ImmutableList<V> get(@Nullable
                                K key)

  Returns an immutable list of the values for the given key. If no mappings in the multimap have the provided key, an empty immutable list is returned. The values are in the same order as the parameters used to build this multimap.

  Specified by:
    `get` in interface `ListMultimap<K,V>`
  Specified by:
    `get` in interface `Multimap<K,V>`
  Specified by:
    `get` in class `ImmutableMultimap<K,V>`
  Parameters:
    `key` - key to search for in multimap
  Returns:
    the collection of values that the key maps to

### removeAll

    public ImmutableList<V> removeAll(Object key)

  Guaranteed to throw an exception and leave the multimap unmodified.

  Specified by:
    `removeAll` in interface `ListMultimap<K,V>`
  Specified by:
    `removeAll` in interface `Multimap<K,V>`
  Overrides:
    `removeAll` in class `ImmutableMultimap<K,V>`
  Parameters:
    `key` - key of entries to remove from the multimap
  Returns:
    the collection of removed values, or an empty collection if no values were associated with the provided key. The collection may be modifiable, but updating it will have no effect on the multimap.
  Throws:
    `UnsupportedOperationException` - always

### replaceValues

    public ImmutableList<V> replaceValues(K key,
                                          Iterable<? extends V> values)

  Guaranteed to throw an exception and leave the multimap unmodified.

  Specified by:
    `replaceValues` in interface `ListMultimap<K,V>`
  Specified by:
    `replaceValues` in interface `Multimap<K,V>`
  Overrides:
    `replaceValues` in class `ImmutableMultimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `values` - values to store in the multimap
  Returns:
    the collection of replaced values, or an empty collection if no values were previously associated with the key. The collection may be modifiable, but updating it will have no effect on the multimap.
  Throws:
    `UnsupportedOperationException` - always

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD